diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/pgc.c linux/fs/reiserfs/pgc.c
--- /usr/src/linux-2.4.9/fs/reiserfs/pgc.c	Thu Jan  1 03:00:00 1970
+++ linux/fs/reiserfs/pgc.c	Sat Aug 25 19:50:45 2001
@@ -0,0 +1,459 @@
+/*
+ * fs/reiserfs/pgc.c
+ *
+ * "Passive garbage collector"
+ *
+ * Keeps disk usage within the bounds specified with pgc=L,H mount option
+ * by unlinking aged files from the blocks that pass through search_by_key.
+ * We never do any active disk scan to find aged files, we just remove them
+ * as they pass by, thus avoiding extra disk activity.
+
+   We might find it to be best to have all read-ahead reach memory
+   rather than staying in just the disk cache, so that PGC can occur
+   on it.  This would involve turning off disk read-ahead and doing it
+   in the FS.. -Hans
+
+ *
+ * Prototype by Nikita Danilov <nikitadanilov@yahoo.com>
+ * Rewritten for use with reiserfs_raw by Yury Shevchuk <sizif@botik.ru>
+ *
+ * Copyright 2000 by Hans Reiser, licensing governed by reiserfs/README
+ *
+ * $Id: pgc.c,v 1.1.4.14 2000/12/22 08:52:04 sizif Exp $ */
+
+#include <linux/fs.h>
+#include <linux/reiserfs_fs.h>
+#include <linux/sched.h>
+#include <asm/uaccess.h>
+#include <linux/smp_lock.h>
+
+
+#define PGC_DEBUG_LEVEL 1
+#define pgc_debug(N, X) \
+  do { if ((N) <= PGC_DEBUG_LEVEL) reiserfs_warning X; } while (0)
+
+/* how often to re-calculate PGC threshold (in seconds) */
+#define PGC_THRESHOLD_PERIOD	 	1
+
+/* The size of the unlink queue.  It should be big enough to contain
+   max number of unlinks we can reap from a single reiserfs node, so
+   we did't lose unlinks.  Note that the q is processed on exit from
+   reiserfs_raw syscalls, and we should account for the possibility
+   of several concurrent processes filling it...  We can make it
+   considerably big, as they are few (one unlinkq per fs mount.) */
+#define PGC_UNLINKQ_SZ			(50 + PAGE_SIZE/RAW_SD_SIZE*50)
+
+/* Size of the rescan protection store */
+#define PGC_SCAN_RECENT_SZ	(MAX_HEIGHT*6 + 2)
+
+struct pgc {
+    unsigned long lo;			/* low water mark, blocks */
+    unsigned long hi;			/* high water mark, blocks */
+    time_t age_threshold;		/* remove files older than this */
+    unsigned long age_threshold_last;   /* last recalculation time (jiffies) */
+    struct age_class age;		/* age class table */
+    struct key unlinkq[PGC_UNLINKQ_SZ];	/* keys queued for unlink */
+    int unlinkq_count;			/* unlinkq filled slot count */
+    int scan_buffer_lock;		/* flag to inhibit scan_buffer
+                                           while processing unlinkq */
+    struct buffer_head *scan_recent[PGC_SCAN_RECENT_SZ];
+    int scan_recent_idx;
+};
+
+
+
+//static read_proc_t pgc_proc_read_age_class;
+static void pgc_shift_if_nec (struct reiserfs_transaction_handle *th);
+static time_t pgc_recalc_threshold_if_nec (struct super_block *sb);
+static void pgc_save_age_class (struct reiserfs_transaction_handle *th);
+static void pgc_restore_age_class (struct super_block *sb);
+static int  pgc_push_unlinkq (struct super_block *sb, struct key *);
+
+
+
+int
+pgc_init (struct super_block *sb)
+{
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+
+    rsi->pgc = reiserfs_kmalloc (sizeof (struct pgc), GFP_KERNEL, sb);
+    if (! rsi->pgc) {
+	pgc_debug (1, ("pgc_init: no mem for PGC control data for %s\n",
+		       bdevname (sb->s_dev)));
+	return -1;
+    }
+    rsi->pgc->unlinkq_count = 0;
+    rsi->pgc->scan_buffer_lock = 0;
+    rsi->pgc->scan_recent_idx = 0;
+    rsi->pgc->age_threshold = 0;
+    rsi->pgc->age_threshold_last = jiffies;
+
+    pgc_restore_age_class (sb);
+    if (! rsi->pgc->age.total)
+        age_class_init (&rsi->pgc->age, CURRENT_TIME);
+  //reiserfs_proc_register (sb, "age_class", pgc_proc_read_age_class);
+    return 0;
+}
+
+void
+pgc_cleanup (struct super_block *sb, struct reiserfs_transaction_handle *th)
+{
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+
+  //reiserfs_proc_unregister(sb, "age_class");
+    pgc_save_age_class (th);
+    reiserfs_kfree (rsi->pgc, sizeof (struct pgc), sb);
+}
+
+
+/* Convers PGC thresholds from per cents to block counts and store
+   them in the pgc info structure */
+
+void
+pgc_set_thresholds (struct super_block * s, int lo, int hi)
+{
+    struct reiserfs_super_block * rs = SB_DISK_SUPER_BLOCK (s);
+    struct pgc *pgc = s->u.reiserfs_sb.pgc;
+
+    if (!pgc)
+	return;
+
+    pgc->lo = le32_to_cpu (rs->s_block_count)/100 * lo;
+    pgc->hi = le32_to_cpu (rs->s_block_count)/100 * hi;
+}
+
+
+
+/* The main function of PGC.  Scan reiserfs formatted node looking for
+   aged stat data; if found, unlink the files */
+
+void
+pgc_scan_buffer (struct super_block *sb, struct buffer_head *bh)
+{
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+    struct pgc *pgc = rsi->pgc;
+    time_t age_threshold;
+    int i;
+
+    if (! pgc) /* PGC disabled */
+	return;
+
+    /* not sure if we have the lock already.  Get it just in case. */
+    lock_kernel ();
+
+    /* Do nothing if called from pgc_process_unlinkq: these buffers
+       are likely scanned and all unlinkables in them are queued already */
+    if (++pgc->scan_buffer_lock > 1)
+	goto out;
+
+    /* When reiserfs_get_block works, we get the same buffer
+       repeatedly.  Remember the last buffer seen and don't rescan it.
+       More than that, remember several recently scanned buffers.  Or
+       else we get substantial number of repetitions in unlinkq, which
+       result in needless reiserfs_iget for already deleted inodes in
+       pgc_process_unlinkq */
+    i = PGC_SCAN_RECENT_SZ;
+    while (--i >= 0) {
+	if (bh == pgc->scan_recent[i])
+	    goto out;
+    }
+    if (--pgc->scan_recent_idx < 0)
+	pgc->scan_recent_idx = PGC_SCAN_RECENT_SZ-1;
+    pgc->scan_recent[pgc->scan_recent_idx] = bh;
+
+    age_threshold = pgc_recalc_threshold_if_nec (sb);
+    if (! age_threshold)
+	goto out;
+
+    for (i = 0; i < B_NR_ITEMS (bh); i++) {
+	struct item_head *ih = B_N_PITEM_HEAD (bh,i);
+
+	if (ih_item_len (ih) == RAW_SD_SIZE
+	    && ih_version (ih) == ITEM_VERSION_2
+	    && le16_to_cpu (ih->ih_key.u.k_offset_v2.k_type) == TYPE_STAT_DATA) {
+
+	    struct stat_data *sd = B_I_STAT_DATA (bh, ih);
+
+	    if (le32_to_cpu (ATTR_LASTREF (sd)) < age_threshold
+		|| le32_to_cpu (ATTR_EXPIRES (sd)) < CURRENT_TIME) {
+		/* Aged file, remove. */
+		pgc_debug (3, ("%s:%u: queuing unlink %k\n",
+			       __FILE__, __LINE__, &ih->ih_key));
+		/* However tempting it is to call reiserfs_rawunlink2
+		   right now, we will not.  It will attempt to create
+		   a transaction, while we are most likely inside an
+		   open transaction already.  If that open transaction
+		   is not joinable, journal_begin will sleep to let it
+		   finish, which means deadlock.  So queue it and
+		   remove later when we are for sure in user context. */
+		if (pgc_push_unlinkq (sb, &ih->ih_key) < 0)
+		    break;	/* queue overflow */
+	    }
+	}
+    }
+ out:
+    pgc->scan_buffer_lock--;
+    unlock_kernel ();
+}
+
+
+static int
+pgc_push_unlinkq (struct super_block *sb, struct key *kp)
+{
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+    struct pgc *pgc = rsi->pgc;
+
+    if (pgc->unlinkq_count >= PGC_UNLINKQ_SZ) {
+	reiserfs_warning ("pgc_push_unlinkq: queue full (%u), dropping victim\n",
+			  pgc->unlinkq_count);
+	return -1;
+    }
+
+    pgc->unlinkq[pgc->unlinkq_count++] = *kp;
+    return 0;
+}
+
+void
+pgc_process_unlinkq (struct super_block *sb)
+{
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+    struct pgc *pgc = rsi->pgc;
+    time_t age_threshold;
+    unsigned long starttime;
+
+    if (! pgc)			/* PGC disabled */
+	return;
+    if (! pgc->unlinkq_count)	/* nothing queued for unlink */
+	return;
+    if (pgc->scan_buffer_lock)	/* another pgc_process_unlinkq is active */
+	return;
+
+    age_threshold = pgc_recalc_threshold_if_nec (sb);
+    if (! age_threshold) {
+	/* No need for space anymore?  You're free, victims! */
+	pgc->unlinkq_count = 0;
+	return;
+    }
+
+    pgc->scan_buffer_lock++;
+    starttime = jiffies;
+
+    /* Process queue in LIFO order, so we hopefully use recently
+       cached things in CPU cache. */
+
+    while (pgc->unlinkq_count) {
+	struct key *kp = &pgc->unlinkq[--pgc->unlinkq_count];
+	struct cpu_key key;
+	struct inode *inode;
+
+				/* this is an indirect measure, we
+                                   should code to more directly avoid
+                                   doing disk I/O, and this should
+                                   become a debugging check we never
+                                   see, once you have the time to code
+                                   it....:-) -Hans */
+	if (jiffies - starttime > HZ/4) {
+	    /* Looks like the queue grew so long that the least recent
+	       keys got pushed from caches and unlinking them isn't
+	       cheap (probably involves disk access).  Purge the queue
+	       and go pick fresh victims */
+	    pgc_debug (2, ("pgc_process_unlinkq: 0.25s spent in unlinkq\n"));
+	    pgc->unlinkq_count = 0;
+	    break;
+	}
+
+	_make_cpu_key (&key, ITEM_VERSION_2,
+		       le32_to_cpu (kp->k_dir_id),
+		       le32_to_cpu (kp->k_objectid),
+		       SD_OFFSET, TYPE_STAT_DATA, 3/*key length*/);
+				/* need an iget that refuses to read
+                                   disk if reading disk is necessary */
+	inode = reiserfs_iget (sb, &key);
+	if (IS_ERR (inode)) {	/* already deleted.  Was in the queue twice? */
+	    static int i = 0;
+	    i++;
+	    if ((i & (i-1)) == 0)
+		reiserfs_warning ("pgc_process_unlinkq: %u overunlinks total\n", i);
+	    continue;
+	}
+	/* check to make sure it didn't get accessed while sitting on
+	   the unlinkq, since if it did we should not unlink it. */
+	if (inode->u.reiserfs_i.lastref < age_threshold 
+	    || inode->u.reiserfs_i.expires < CURRENT_TIME) {
+	    reiserfs_rawunlink2 (inode);
+	}
+	else {
+	    /* someone referenced the file in the last second...
+	       let it go free */
+	    iput (inode);
+	}
+    }
+
+    pgc->scan_buffer_lock--;
+}
+
+
+/* Return the coarse-grained current time for use as lastref. */
+
+time_t
+pgc_current_time (struct super_block *sb)
+{
+    struct pgc *pgc = sb->u.reiserfs_sb.pgc;
+
+    if (! pgc)
+	return CURRENT_TIME;
+    return pgc->age.class[0].t + 1;
+}
+
+
+/* Update age class counters, and schedule the update to disk in the
+   same transaction which will write updated stat data of the inode
+   that caused the update */
+
+void
+pgc_age_class_update (struct reiserfs_transaction_handle *th,
+		      time_t old_lastref,
+		      time_t new_lastref)
+{
+    struct super_block *sb = th->t_super;
+    struct pgc *pgc = sb->u.reiserfs_sb.pgc;
+
+    if (! pgc)			/* PGC disabled */
+	return;
+    if (sb->s_flags & MS_RDONLY)
+	return;
+
+    pgc_shift_if_nec (th);
+    if (old_lastref) age_class_update (&pgc->age, old_lastref, -1);
+    if (new_lastref) age_class_update (&pgc->age, new_lastref, +1);
+    pgc_save_age_class (th);
+}
+
+
+/* Periodic class counter shift procedure.  First implementation
+   attempt used timers, but that implies the need for extensive
+   locking, so we'll better do this in user context. */
+
+static void
+pgc_shift_if_nec (struct reiserfs_transaction_handle *th)
+{
+    struct super_block *sb = th->t_super;
+    struct age_class *age = &sb->u.reiserfs_sb.pgc->age;
+
+    if (age->class[0].t >= CURRENT_TIME) /* recently shifted */
+	return;
+
+    if (age_class_shift (age, CURRENT_TIME))
+	pgc_save_age_class (th);
+}
+
+
+/* Periodic age threshold update procedure: calculates age_threshold
+   for GC based on current disk usage */
+
+static time_t
+pgc_recalc_threshold_if_nec (struct super_block *sb)
+{
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+    struct reiserfs_super_block *rs = SB_DISK_SUPER_BLOCK (sb);
+    struct pgc *pgc = rsi->pgc;
+    unsigned long du = (le32_to_cpu (rs->s_block_count)
+			- le32_to_cpu (rs->s_free_blocks));
+    unsigned unlink_ratio;
+
+    if ((jiffies - pgc->age_threshold_last) < PGC_THRESHOLD_PERIOD*HZ)
+	goto out; /* don't recalculate too often. */
+
+    pgc_debug (2, ("%s:%u: used=%lu pgclo=%lu pgchi=%lu j=%lu, last=%lu\n",
+		   __FILE__, __LINE__, du, pgc->lo, pgc->hi,
+		   jiffies, pgc->age_threshold_last));
+
+    if (du < pgc->lo) {
+	/* low disk usage, no need to clean anything yet */
+	unlink_ratio = 0;
+	pgc->age_threshold = 0;
+    }
+    else {
+	/* When disk usage exceeds pgclo, we start removing; the
+	   closer to pgchi, the more aggressive.  At pgclo, we want to
+	   remove 5 files of 100 on the average, at pgchi we want to
+	   remove 95 files of 100.  TODO: see if the numbers are
+	   chosen well.  Make them configurable via /proc? */
+#define LO_RATIO 5
+#define HI_RATIO 95
+	unlink_ratio = (LO_RATIO
+			+ ((du - pgc->lo)
+			   * (HI_RATIO - LO_RATIO)
+			   / (pgc->hi - pgc->lo + 1/*avoid div by 0*/)));
+	if (unlink_ratio > HI_RATIO)
+	    unlink_ratio = HI_RATIO;
+
+	pgc->age_threshold =
+	    age_class_threshold (&pgc->age, unlink_ratio, CURRENT_TIME);
+    }
+
+    pgc->age_threshold_last = jiffies;
+
+    pgc_debug (2, ("%s:%u: unlink_ratio=%lu, set age_threshold=%lu\n",
+		   __FILE__, __LINE__,
+		   unlink_ratio, pgc->age_threshold));
+ out:
+    return pgc->age_threshold;
+}
+
+
+
+/* proc read routine for /proc/fs/reiserfs/XXX/age_class */
+/*
+static int
+pgc_proc_read_age_class (char *buffer, char **start, off_t offset,
+			 int count, int *eof, void *data)
+{
+    struct super_block *sb = (void *) data;
+    struct reiserfs_sb_info *rsi = &sb->u.reiserfs_sb;
+    int len = 0;
+
+    len += sprintf (&buffer[len], "Age threshold: %lu\n",
+		    rsi->pgc->age_threshold);
+
+    age_class_dump (&rsi->pgc->age, CURRENT_TIME, &buffer[len], PAGE_SIZE-len);
+    len = strlen (buffer);
+
+    if (offset >= len) {
+	*start = buffer;
+	*eof = 1;
+	return 0;
+    }
+    *start = buffer + offset;
+    if ((len -= offset) > count)
+	return count;
+    *eof = 1;
+    return len;
+}
+*/
+
+static void
+pgc_save_age_class (struct reiserfs_transaction_handle *th)
+{
+    struct super_block *sb = th->t_super;
+    struct reiserfs_super_block *rs = SB_DISK_SUPER_BLOCK (sb);
+    struct age_class *age = &sb->u.reiserfs_sb.pgc->age;
+    struct buffer_head *sbh = SB_BUFFER_WITH_SB (sb);
+
+    if (sb->s_flags & MS_RDONLY)
+	return;
+    reiserfs_prepare_for_journal (sb, sbh, 1) ;
+    /* update super block. TODO: should use cpu_to_le32 */
+    memcpy (rs->s_unused, age, sizeof (struct age_class));
+    journal_mark_dirty (th, sb, sbh);
+}
+
+static void
+pgc_restore_age_class (struct super_block *sb)
+{
+    struct reiserfs_super_block *rs = SB_DISK_SUPER_BLOCK (sb);
+    struct age_class *age = &sb->u.reiserfs_sb.pgc->age;
+
+    /* TODO: should use le32_to_cpu */
+    memcpy (age, rs->s_unused, sizeof (struct age_class));
+}
